--- old/usr/src/lib/libsum/Makefile.com	Tue Oct  7 15:48:34 2014
+++ new/usr/src/lib/libsum/Makefile.com	Tue Oct  7 15:48:34 2014
@@ -20,6 +20,8 @@
 #
 
 #
+# Copyright 2014 Gary Mills
+#
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
@@ -77,10 +79,12 @@
 CERRWARN	+= -_gcc=-Wno-parentheses
 
 # This codepath is performance-critical
-sparc_COPTFLAG=-xO5 -_cc=-xprefetch=auto,explicit
-sparcv9_COPTFLAG=-xO5 -_cc=-xprefetch=auto,explicit
-i386_COPTFLAG=-_cc=-xO5 -_cc=-xprefetch=auto,explicit
-amd64_COPTFLAG=-_cc=-xO5  -_cc=-xprefetch=auto,explicit
+sparc_COPTFLAG=-_cc=-xO5 -_gcc=-O2 -_cc=-xprefetch=auto,explicit
+sparcv9_COPTFLAG=-_cc=-xO5 -_gcc=-O2 -_cc=-xprefetch=auto,explicit
+# No optimization for gcc
+i386_COPTFLAG=-_cc=-xO5 -_gcc=-O0 -_cc=-xprefetch=auto,explicit
+amd64_COPTFLAG=-_cc=-xO5 -_gcc=-O0  -_cc=-xprefetch=auto,explicit
+amd64_ADJCOPT=$(ADJUST_OPT1)
 
 # Suppress this one warning as the fix would break old gcc, which upstream
 # still supports. This needs a better fix (later).
